<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html xmlns="http://www.w3.org/TR/REC-html40"> 
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>fwAccessControl_EditDomain.pnl 
panel</title>
<link rel="StyleSheet" HREF="style.css" TYPE="text/css" MEDIA="screen,print">
</head>
<body>
<table width="95%" border="1"><tbody>
<tr vAlign="top">
<td width="22%" bgColor="#00cc00"><strong>Panel Name</strong></td>
<td width="78%" colSpan="2">fwAccessControl/fwAccessControl_EditDomain.pnl</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Introduction<br></strong></td>
<td colSpan="2">
<p>Edit Domain panel</p>
<p> 
    <p>
    This panel is used to display and edit the details of the domain, and to create new domains.
    </p>
    The panel has three modes of operation, determined by the access rights and the dollar parameter 
    <code>$mode</code> (see below): 
    <dl>
	<dt> <em>Edit</em> mode</dt>
	<dd> presented in Figure 1, allow to edit the details of the domain. This mode is active
	if the user has the Domain Administration access rights, the mode of the panel specified by
	<code>$mode</code> is not "RO", and non-empty name of the domain was passed as the
	<code>$domainName</code> parameter.
	    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_EditDomain.png"></td></tr>
<tr><td><span class="caption">Figure 1: Edit Domain panel in the "edit" mode</span></td></tr>
</table></div>
	In the edit mode, the <span class="button">Reset</span>, <span class="button">Holders...</span>, <span class="button">OK</span> 
	and <span class="button">Close</span>buttons are available.
	</dd>

	<dt> <em>View</em> mode </dt>
	<dd> presented in Figure 2, only displays the details of the domain and does not allow for changes.
	This mode is active
	if the user has no Domain Administration access rights, or the read-only mode of the panel was
	requested by setting the
	<code>$mode</code> to "RO".
	    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_EditDomain_view.png"></td></tr>
<tr><td><span class="caption">Figure 2: Edit Domain panel in the "view" mode</span></td></tr>
</table></div>

	In the view mode, only <span class="button">Holders...</span> and <span class="button">Close</span>buttons are available.

	</dd>

	<dt> <em>Create</em> mode </dt>
	<dd> presented in Figure 3, is used to create a new domain. This mode is active
	    if the <code>$domainName</code> parameter passed to the panel contained an empty string.
	    <div xmlns:html="http://www.w3.org/1999/xhtml" class="figure"><table align="center">
<tr><td><img src="fwAccessControl_EditDomain_create.png"></td></tr>
<tr><td><span class="caption">Figure 3: Edit Domain panel in the "create" mode</span></td></tr>
</table></div>
	    
        In the create mode, the <span class="button">Reset</span>, <span class="button">Create</span>
	and <span class="button">Close</span>buttons are available.

	</dd>	
    </dl>
    
    <p>
    The panel comprises the following elements:
    <ul>
	<li>
	<em>Domain name</em> text line defines the domain name, which identifies the domain in a unique way.
	Note that the <strong>Name_Domain</strong> restriction apply (see the <em>Restrictions</em> below)
	for domain names.
	</li>

	<li> <em>Domain full name</em> text line defines the full name of the domain; it is free of restrictions
	concerning the characters used within (i.e. it may contain spaces).<br>
	 Note that the full name is displayed in the
	<a href="fwAccessControl_DomainList.htm">Domain List</a>  panel, and the filter therein applies to the domain name and the
	domain full name. It is recommended (yet not required) to define non-empty and unique domain full name.
	</li>
	
	<li>
	<em>Description</em> text line contains any additional information - it's meaning is not defined;
	it may be left empty.
	</li>
	
	<li>
<em>id</em> text line (not editable) displays the internal unique identifier of the domain. It
	is assigned automatically and may not be modified. This field is empty in the <em>create</em> mode of the panel.
	This idenifier may be of use for the experts and for debugging purposes.
	</li>

	<li>
<em>Privileges</em> table: displays the names of the privileges in the domain. If the panel is open in 
	the <em>edit</em> or <em>create</em> mode, privileges' names may be edited directly in the table.
	The numbers left to the names - privilege levels - are the internal identifiers of the privileges;
	they may be of use for experts or debugging; they may not be changed.
	</li>
	
	<li> <span class="button">Reset</span> button: undoes the changes done in the panel, i.e. in the <em>edit</em>
	mode resets the contents of all editable fields so that they represent the current settings, while
	in the <em>create</em> mode it clears the text fields and sets default privilege names in the table.
	Pressing this button does not apply any settings; it does not close the panel either.
	</li>
	
	<li> <span class="button">Holders...</span> button: allows to display the users and groups having certain privileges:
	    it brings up the <a href="fwAccessControl_PrivHoldersList.htm">Privilege Holders List</a>  panel,
	    with the domain name preset to the currently edited (inspected) domain, and the privilege name
	    preset to the name of the privilege selected currently in the <em>Privileges</em> table.<br>
	    Note that this button is disabled until you select a privilege in the <em>Privileges</em> table.
	</li>
	
	<li> <span class="button">OK</span> (in <em>edit</em> mode) or <span class="button">Create</span>
	    (in <em>create</em> mode): applies the changes, i.e. modifies or creates the domain,
	    and closes the panel.
	</li>
	
	<li> <span class="button">Close</span> button: closes the panel without applying the changes.
	</li>
	
    </ul>    
    </p>
    
    </p>
<br>
</td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Instructions</strong></td>
<td colSpan="2"><dl>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To create a domain:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Open the panel in the <em>create</em> mode 
	(e.g. click the <span class="button">Add</span>
	in the <a href="fwAccessControl_DomainList.htm">Domain List</a>  panel, which
	may be opened using the <span class="button">Administration&gt;Domains</span> context menu of
	the <a href="fwAccessControl_Toolbar.htm">Toolbar</a>  panel). <br>
	Fill-in at least the domain name
	then press the <span class="button">Create</span> button
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To rename a domain:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Make sure the panel is open in the <em>edit</em> mode, for the domain you wish to rename;
	type in the modified name into the <em>Domain name</em> text field, 
	then press the <span class="button">OK</span> button to apply the changes. You may want to alter other 
	settings of the domain at the same time, before pressing <span class="button">OK</span>.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To change the names of privileges:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Make sure the panel is open in the <em>edit</em> mode;
	type in the new names of the privileges directly in the
	<em>Privileges</em> table, 
	then press the <span class="button">OK</span> button to apply the changes. You may want to alter other 
	settings of the domain at the same time, before pressing <span class="button">OK</span>.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To change the full name or description:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Make sure the panel is open in the <em>edit</em> mode;
	type in the new full name or description in the appropriate fields,
	then press the <span class="button">OK</span> button to apply the changes. You may want to alter other 
	settings of the domain at the same time, before pressing <span class="button">OK</span>.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To find a user/group having certain access right:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	Open the panel for the domain in which you want to look for access right,
	click on the privilege name in the <em>Privileges</em> table,
	then click on the <span class="button">Holders...</span> button.
	This will bring up the <a href="fwAccessControl_PrivHoldersList.htm">Privilege Holders List</a>  panel;
	follow the instructions for that panel.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To delete a domain:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml">
	You need to use the <span class="button">Delete</span> button in  the <a href="fwAccessControl_DomainList.htm">Domain List</a> 
	panel; it is available, for instance, from the <span class="button">Administration&gt;Domains</span> context menu of the 
	<a href="fwAccessControl_Toolbar.htm">Toolbar</a>  panel.
    </dd>
<dt xmlns:html="http://www.w3.org/1999/xhtml">To cancel the changes:</dt>
<dd xmlns:html="http://www.w3.org/1999/xhtml"> Press the <span class="button">Close</span> button </dd>
</dl></td>
</tr>
<tr vAlign="top">
<td bgColor="#00cc00"><strong>Restrictions</strong></td>
<td colSpan="2"><ul>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>Access_Domain:</strong> To edit an existing domain, or create a new domain one needs the Domain Administration
	(or System Administration)
	access rights (see also the <a href="fwAccessControl_Setup.htm">Setup Panel</a> ).</li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>Name_Domain:</strong> Domain name must not contain the space ( ), colon (:), semicolon (;), pipe (|), 	
	backslash (\), asterisk (*), apostrophe (') and double-quotes (") characters. 
	The slash (/) parameter is allowed and recommended as logical separator.
	Domain full name and description are, however, free of limitations.<br>
	The domain name needs to be unique.
    </li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>Name_Prvilege:</strong> Privilege name must only contain alpanumeric characters (letters, digits).
	 It is recommended that privilege names are single words; if multiple words need to be used to describe the privilege,
	the <em>InterCaps</em> notation (joining the words while capitalizing the first letters) is recommended,
	even though space character ( ) is allowed in privilege names.
	<br>
	Privilege names <em>within the domain</em> need to be unique (yet they does not need to be across the domains,
	e.g. there may be <code>Control</code> privilege in domains <code>Domain1</code> and 
	<code>Domain2</code>, resulting in unique access rights <em>Domain1:Control</em> and
	<em>Domain2:Control</em> respectively.
    </li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>UNICOS_Domain:</strong> In the UNICOS mode of operation, it is not possible to change the full name
    and the description of the domain.
    </li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>System_Domain:</strong> The name and full name of the system domain are not allowed. The changes in the
    system domain description will be discarded. The name of the system domain is always equal to the name of the local
    system. The id of the system domain is -1.
    </li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>System_Privileges:</strong> The privileges in the system domain reflect the set of 32 PVSS system privileges.
    It is recommended not to change the names of the first five privileges. Privileges from 21 to 32 are reserved for
    the JCOP Framework Access Control - their names should not be changed and they may not be used for own purposes.
    Note that all users will always have privilege level 1 and privileges 21-28 granted.
    </li>
<li xmlns:html="http://www.w3.org/1999/xhtml">
<strong>Privilege_Numbers:</strong> Each non-system domain may have up to 8 privileges defined  with id's in
    the range [21,28]). In the UNICOS mode, each domain has 4 privileges.
    </li>
</ul></td>
</tr>
</tbody></table>
<br><table width="95%" border="1"><tbody>
<tr bgColor="#00cc00"><td colSpan="3"><strong>Dollar Parameters</strong></td></tr>
<tr bgColor="#00cc00">
<td width="23%"><strong>Name</strong></td>
<td width="62%"><strong>Description</strong></td>
<td width="15%">&nbsp;</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td>$domainName</td>
<td> 
	Specifies the name of the domain to edit. Passing an empty string (<code>""</code>) will open the panel in the 
	<em>create</em> mode.
    </td>
<td>required</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td>$mode</td>
<td> 
	If set to <code>"RO"</code>, the panel will be opened in the <em>view</em> mode. 
    </td>
<td>optional</td>
</tr>
</tbody></table>
<br>
<table width="95%" border="1"><tbody>
<tr bgColor="#00cc00"><td colSpan="3"><strong>Return Values from panel</strong></td></tr>
<tr><td colspan="3"> The panel should be opened using functions from the
	    <code>ChildPanel...Returns(... , df,ds)</code> family. <br>
	    When the panel is closed the following
	    values may be returned in the <code>df</code> and <code>ds</code> parameters:
	</td></tr>
<tr bgColor="#00cc00">
<td width="60"><strong>Variable</strong></td>
<td width="10%"><strong>Value(s)</strong></td>
<td><strong>Description</strong></td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_float</code>  parameter (<code>df[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>1</code></td>
<td> Edit action terminated succesfully, <span class="button">OK</span> button pressed</td>
</tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>df[1]</code></td>
<td><code>0</code></td>
<td> Edit action cancelled, <span class="button">Close</span> button pressed</td>
</tr>
<tr bgColor="#ccffcc"><td colspan="3" align="center">
<code>dyn_string</code> parameter (<code>ds[]</code>)</td></tr>
<tr xmlns:html="http://www.w3.org/1999/xhtml">
<td><code>ds[]</code></td>
<td><code></code></td>
<td> not used: empty variable is always returned.</td>
</tr>
</tbody></table>
<br><a href="../../fwAccessControl.htm">
Back to the documentation of the
	    fwAccessControl
component.
	    </a> <br xmlns:html="http://www.w3.org/1999/xhtml"><hr xmlns:html="http://www.w3.org/1999/xhtml">
<font xmlns:html="http://www.w3.org/1999/xhtml" size="-1"> Piotr Golonka, <a href="http://cern.ch/itcobe">CERN IT/CO-BE</a></font>
</body></html>
